#include <zephyr/net/wifi.h>
#include <zephyr/net/wifi_mgmt.h>
#include <zephyr/net/net_mgmt.h>
#include <net/wifi_mgmt_ext.h>
#include <net/wifi_credentials.h>

#include <zephyr/net/net_event.h>
#include <zephyr/net/net_if.h>

extern struct k_sem run_app;

#define WIFI_TRIAL_LIMIT	30 //WIFI_TRIAL_LIMIT*10 seconds

enum wifi_conn_cases {
    WIFI_CONNECTION_SUCCESSFUL = 1,
    WIFI_INCORRECT_PASSWORD = 2,
    WIFI_SMALL_PASSWORD_LENGTH = 3,
    WIFI_CONNECT_TIMEOUT = 4,
    WIFI_DISCONNECTED = 5,

};

enum wifi_status_cases {
    WIFI_CONNECTED_STATE = 1,
    CONNECTING_TO_WIFI_FAILED = 2,
    DISCONNECTING_FROM_WIFI_FAILED = 3,
    INCORRECT_PASSWORD = 4,
    NO_OF_TRIALS_EXCEEDED = 5,
    WIFI_RECONNECTION = 6,
    CONNECTING_TO_WIFI_FAILED_OTHER_ERR = 7,
    WIFI_DISCONNECTED_STATE = 9,  
};

int wifi_sem_init(void);
void wifi_callbacks_init(void);
void net_mgmt_event_handler(struct net_mgmt_event_callback *cb, uint32_t mgmt_event, struct net_if *iface);
int wifi_args_to_params(struct wifi_connect_req_params *params);
int connect_wifi(void);
int cmd_wifi_status(void);
int reconnect_wifi(void);
void switch_wifiCred_thread_init(void);
void wifi_reconnect_thread(void);
int wifi_connect_trial(int trial_count);
void reset_wifi_trials(void);